//<c>   Copyright 1996-2000 by Gerry J. Danen; all rights reserved.

//<t>   Check .ZIP files for valid DOS file names (cloned from FILESBBS.C)

//      Sets errorlevel 0 = all files are valid
//                      1 = found invalid filenames
//                      2 = syntax error/help
//                      3 = no files processed
//                      4 = cancelled by user
//                      5 = no TEMP variable found
//                      9 = memory or disk problem

//      This is preliminary code ... needs work!

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_ansi.h"
#include<search.h>


#define pgVERS_ "V1.30"
#define pgTITL_ "Check .ZIP Files for Valid DOS File Names"
#define pgCOPR_ "1996"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define MAXFLS  10000                           // max number of files
#define BUFSIZE 1000
FILE    *fd1, *fd2 ;
UCHAR   fl_1[FS_LEN], fl_2[FS_LEN], tmpFile[FS_LEN], tmpLocation[FS_LEN],
        work[BUFSIZE+1], work80[81], cmd[BUFSIZE+1], *pcmd, curdir[FS_LEN] ;
static  char    *ftable[MAXFLS+1] ;
long    found = 0L, probFound = 0L, probFiles = 0L ;
int     ft_entries=0, attrib = REGULAR_FILES ;
struct  find_t dta ;


union   fileDateUnion
{
        ms_date_t dt ;
        unsigned ndt ;
}       fldate ;


typedef struct
{
        UCHAR   ext[4] ;                        // e.g., ZIP, ARJ, RAR
        STRING  cmd ;                           // list command, e.g., pkzip -vbn
        int     fnloc ;                         // which word in the line holds the filename, -1 = last
}       archive_handling_t_ ;
archive_handling_t_     ah[20] ;                // room for 20


void    syntax( void )
{
    logon(1);
    printf( "\n***PRE-RELEASE VERSION***\n\n"
            "\nUsage:\n\t%s [fspec]\n\n"
            "\tWhere fspec contains the zip file name to check;\n"
            "\tif no extention, .zip is assumed;\n"
            "\twildcards (* and ?) are allowed, but no path.\n\n"
            "Example:\n\t%s *\n\n",
            get_global_program_name(), get_global_program_name() );
    exit( 2 );
}


void    check_for_key( void )
{
    if ( kbhit() )
    {
        if ( getch() == 27 )
        {
            printf( "\nCancelled by user\a\n" );
            exit( 3 );
        }
    }
}


int     qs_compare( const char **arg1, const char **arg2 )
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    ftable_update( char fname[] )
{
    strcpy( cmd, fname );
    st_reduce_spaces( cmd );
    st_trim( cmd );
    pcmd = strchr( cmd, '.' );
    if ( pcmd != NULL )
        *pcmd = EOS ;
    strupr( cmd );
    if ( strlen(cmd) )
    {
        if ( ft_entries < MAXFLS )
        {
            ftable[ft_entries] = _strdup(cmd);
            if ( ftable[ft_entries] == NULL )
                exit( 9 );
            ft_entries += 1 ;
        }
        else
        {
            printf( "Too many entries in the file table: %s skipped\n", fname );
        }
    }
    found += 1L ;
}


void    load_ah_table( STRING entry )
{
}


BOOL    valid_DOS_filename( STRING fn )
{
    UCHAR   drv[1024], dir[1024], fname[1024], fext[1024] ;

    _splitpath( fn, drv, dir, fname, fext );

   fprintf( fd2, "%10s [%s] [%s] [%s] [%s]\n", "::", drv, dir, fname, fext );

    if ( strlen(drv) )                          // .zips don't have drive
        return( FALSE );

    if ( strlen(fext) )                         // must be .xxx or blank
    {
        if ( fext[0] != '.' )
            return( FALSE );
        if ( strlen(fext) > 4 )
            return( FALSE );
    }
    if ( strlen(fname) > 8 )                    // max 8 chars
        return( FALSE );

//~~~
    if ( strlen(dir) )                          // gotta take it apart...
    {
    }

    return( TRUE );
}


void    process_zip_list( void )
{
    BOOL        inProcess = FALSE, isError = FALSE ;
    int         erCount = 0 ;
    STRING      erFmt = "%10s %s\n" ;

    if ( ( fd1 = fopen( tmpFile, "r" ) ) == NULL )
    {
        fprintf( fd2, "<<<ERROR>>> cannot open %s\n", tmpFile );
        return ;
    }

    while ( fgets( work, (sizeof(work)-1), fd1 ) )
    {
        isError = FALSE ;
        check_for_key();
        st_rtrim( work );
        ST_CPY( work80, work );
        st_remove_spaces( work80 );
        work80[15] = EOS ;
        if ( strlen(work) )
        {
            if ( inProcess )
            {
                if ( st_eq(work80, "---------------") )
                {
                    work80[0] = EOS ;
                    inProcess = FALSE ;
                }
            }
            if ( inProcess )
            {
                ST_CPY( cmd, st_ptr_last_word( work ) );  // get last word
                if ( strlen(cmd) > 64 )
                {
                    fprintf( fd2, erFmt, "Max64:", cmd );
                    probFound ++ ;
                    isError = TRUE ;
                }
                if ( (strlen(cmd)+strlen(curdir)) > 66 )  // don't forget "\" ...
                {
                    fprintf( fd2, erFmt, "TooLong:", cmd );
                    probFound ++ ;
                    isError = TRUE ;
                }
                if ( ! valid_DOS_filename( cmd ) )
                {
                    fprintf( fd2, erFmt, "InvName:", cmd );
                    probFound ++ ;
                    isError = TRUE ;
                }
                if ( isError )
                {
                    erCount ++ ;
                    fprintf( stderr, "\r%-40s\r  Problem: %s\n", "", cmd );
                }
                else
                {
//~~~
//                  fprintf( fd2, erFmt, "", cmd );
//~~~
                }
            }
            if ( ! inProcess )
            {
                if ( st_eq(work80, "---------------") )
                    inProcess = TRUE ;
            }
        }
    }
    fclose( fd1 );
    if ( erCount )
        probFiles ++ ;
}


void    process_entry( char fname[], int iCount, int iTotal )
{
    int done ;

    if ( iTotal == 1 )
        fprintf( stderr, "\r%-40s\rWorking...", "" );
    else
        fprintf( stderr, "\r%-40s\r%d of %d: %s", "", iCount, iTotal, fname );
    strupr ( fname );

    sprintf( work, "%s.ZIP", fname );
    fprintf( fd2, "%s\n", work );
    done = _dos_findfirst( work, attrib, &dta );
    if ( done )
    {
        fprintf( fd2, "<<<ERROR>>> %s is now missing!\n\n", work );
        return ;
    }

    fl_delete( tmpFile );

    check_for_key();

    sprintf( work, " pkzip -vbn %s >%s ", fname, tmpFile );
    system ( work );

    process_zip_list();                         // process list file
}


void    main( int argc, char *argv[] )
{
    int done ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 2 )
        syntax();

    _getcwd( curdir, sizeof(curdir) );          // save current directory

    fl_get_pgm_def( tmpLocation, "temp", "", YES );
    if ( ! strlen(tmpLocation) )
    {
        printf( "\rEnvironment variable or global .ini entry TEMP must be specified.\n" );
        exit( 5 );
    }

//~~~
    // these should come from global .ini file
    // arch01=ZIP,-1,pkzip -vbn
    load_ah_table( "ZIP,-1,pkzip -vbn" );




    ST_CPY( fl_1, argv[1] );
    strupr( fl_1 );
    pcmd = strchr( fl_1, '.' );
    if ( pcmd == NULPTR )
        ST_CAT( fl_1, ".ZIP" );

    sprintf( tmpFile, "%s\\%s.$$$", tmpLocation, get_global_program_name() );
    sprintf( fl_2, "%s\\%s.OUT", tmpLocation, get_global_program_name() );
    fd2 = fopen( fl_2, "w" );
    if ( fd2 == NULL )
    {
        printf( "Cannot open output file: %s\n", fl_2 );
        exit( 9 );
    }

    //          count first how many files to process and load table
    done = _dos_findfirst( fl_1, attrib, &dta );
    while ( ! done )
    {
        ftable_update( dta.name );
        done = _dos_findnext( &dta );
    }

    fprintf( stderr, "Checking %s in %s\n", fl_1, curdir );

    qsort( (char *)ftable, (size_t)ft_entries, (size_t)sizeof(char *), qs_compare );
    for ( done=0 ; done<ft_entries ; done++ )   // now write the output file
        process_entry( ftable[done], done+1, ft_entries );

    _fcloseall();

    fl_delete( tmpFile );

    fprintf( stderr, "\r%40s\r%ld archive%s processed - report in %s\n",
                     "", found, ONE_OR_MORE(found), fl_2 );

    if ( found == 0 )                           // no files processed
        exit( 3 );

    if ( probFound == 0 )                       // no problems found
        exit( 0 );

    fprintf( stderr, "%ld problem%s were found in %ld file%s!\a\n",
                     probFound, ONE_OR_MORE(probFound),
                     probFiles, ONE_OR_MORE(probFiles) );
    exit( 1 );                                  // files with problems found
}
